#include <wchar.h>
#include <string.h>
#include <memory.h>
#include <unistd.h>
#include "../gdbm-local.h"
#include "../curses.h"
#include "../struktury_dbm.h"
#include "../struktury.h"
#include "../lib.h"
#include "../lib_dbm.h"


struct zaznam pomocny, nacteno;

void zmen_kod(int radek, int sloupec);
void zmen_nazev(int radek, int sloupec);
void zmen_semsetr(int radek, int sloupec);
void zmen_vsemestru(int radek, int sloupec);
void zmen_kreditu(int radek, int sloupec);
void zmen_znamka(int radek, int sloupec);


void pom_tisk(void)
{
    mvprintw8(1, 0, L"New:%4ls %-40ls %5i %5i %6i %6i", pomocny.kod,
	      pomocny.nazev, pomocny.semestr, pomocny.vsemestru,
	      pomocny.kreditu, pomocny.znamka);
}

void zaznam_prepis(DBM * dbm_ptr, wchar_t * kod, int radek)
{
    datum klic;
    datum data;
    wint_t klavesa;

    klic.dptr = (void *) kod;
    klic.dsize = wcslen(kod) * sizeof(kod[0]);

    data = dbm_fetch(dbm_ptr, klic);

    if (!data.dptr)
	return;

    memcpy(&nacteno, data.dptr, data.dsize);
    memcpy(&pomocny, &nacteno, sizeof(struct zaznam));

    attron(COLOR_PAIR(SVETLEM));
    if (!pomocny.vsemestru)
	attron(A_BOLD);
    move(0, 0);
    clrtoeol();
    mvprintw8(0, 0, L"Old:%4ls %-40ls %5i %5i %6i %6i", nacteno.kod,
	      nacteno.nazev, nacteno.semestr, nacteno.vsemestru,
	      nacteno.kreditu, nacteno.znamka);
    pom_tisk();
    refresh();

    echo();
    move(radek, 0);
    clrtoeol();
    zmen_kod(radek, 4);
    zmen_nazev(radek, 9);
    zmen_semsetr(radek, 54);
    zmen_vsemestru(radek, 60);
    zmen_kreditu(radek, 67);
    zmen_znamka(radek, 74);
    noecho();
    attroff(COLOR_PAIR(SVETLEM));
    if (!pomocny.vsemestru)
	attroff(A_BOLD);


    mvprintw(3, 0, "PŘEPSAT STARÝ ZÁZNAM NOVÝM? [Ano/Ne] ");
    refresh();
    do {
	(void) get_wch(&klavesa);
	switch (klavesa) {
	case L'n':
	case L'N':
	    move(3, 0);
	    clrtoeol();
	    return;
	    break;
	}
    }
    while (klavesa != L'a' && klavesa != L'A');


    klic.dptr = (void *) pomocny.kod;
    klic.dsize = wcslen(pomocny.kod) * sizeof(pomocny.kod[0]);

    data.dptr = (void *) &pomocny;
    data.dsize = sizeof(struct zaznam);

    if (!wcscmp(pomocny.kod, nacteno.kod)) {
	if (dbm_store(dbm_ptr, klic, data, DBM_REPLACE))
	    fprintf(stderr, "\nZáznam nelze uložit!\n");
    } else {
	if (dbm_store(dbm_ptr, klic, data, DBM_INSERT)) {
	    attron(COLOR_PAIR(CERVENA));
	    attron(A_BOLD);
	    mvprintw(3, 0, "Záznam s klíčem \"%ls\" již existuje!\t\t",
		     pomocny.kod);
	    attroff(COLOR_PAIR(CERVENA));
	    attroff(A_BOLD);
	    refresh();
	    sleep(2);
	} else {
	    klic.dptr = (void *) nacteno.kod;
	    klic.dsize = wcslen(nacteno.kod) * sizeof(nacteno.kod[0]);
	    dbm_delete(dbm_ptr, klic);
	}
    }

    move(3, 0);
    clrtoeol();
    return;
}


/*********************************************************************/

void zmen_kod(int radek, int sloupec)
{
    move(radek, sloupec);
    getn_wstr((wint_t *) pomocny.kod,
	      sizeof(pomocny.kod) / sizeof(pomocny.kod[0]) - 1);
    velka_pismena(pomocny.kod);
    if (!wcscmp(pomocny.kod, L""))
	wcscpy(pomocny.kod, nacteno.kod);
    pom_tisk();
}

void zmen_nazev(int radek, int sloupec)
{
    move(radek, sloupec);
    getn_wstr((wint_t *) pomocny.nazev,
	      sizeof(pomocny.nazev) / sizeof(pomocny.kod[0]) - 1);
    if (!wcscmp(pomocny.nazev, L""))
	wcscpy(pomocny.nazev, nacteno.nazev);
    pom_tisk();
}

void zmen_semsetr(int radek, int sloupec)
{
    do {
	move(radek, sloupec);
	clrtoeol();
	scanw("%i", &pomocny.semestr);
    }
    while (pomocny.semestr < 1 || pomocny.semestr > SEMESTRU);
    pom_tisk();
}


void zmen_vsemestru(int radek, int sloupec)
{
    do {
	move(radek, sloupec);
	clrtoeol();
	scanw("%i", &pomocny.vsemestru);
    }
    while (pomocny.vsemestru < 0 || pomocny.vsemestru > SEMESTRU);
    pom_tisk();
}


void zmen_kreditu(int radek, int sloupec)
{
    do {
	move(radek, sloupec);
	clrtoeol();
	scanw("%i", &pomocny.kreditu);
    }
    while (pomocny.kreditu < 0);
    pom_tisk();
}


void zmen_znamka(int radek, int sloupec)
{
    do {
	move(radek, sloupec);
	clrtoeol();
	scanw("%i", &pomocny.znamka);
    }
    while ((pomocny.znamka < 0 || pomocny.znamka > 3) ||
	   (pomocny.znamka && !pomocny.vsemestru));
    pom_tisk();
}
